<?php

if(!defined('VALID_CMS')) { die('ACCESS DENIED'); }

function bookmarks(){

    $inCore = cmsCore::getInstance();
    $inPage = cmsPage::getInstance();
    $inDB   = cmsDatabase::getInstance();
	$inUser = cmsUser::getInstance();

    global $_LANG;

    $inCore->loadModel('bookmarks');
    $model  = new cms_model_bookmarks();

	// id закладки
	$id     = $inCore->request('id', 'int', 0);
	// логин пользователя
	$login  = $inCore->request('login', 'str', ''.$inUser->login.'');
	$do     = $inCore->request('do', 'str', 'view');
	
	// Неавторизованных просим авторизоваться
	if (!$inUser->id && $do != 'add') { cmsUser::goToLogin(); }

	$usr = $model->getUserBylogin($login);
	if (!$usr) { cmsCore::error404(); }
	
	$myprofile = ($inUser->id == $usr['id']);

	$inPage->addPathway($usr['nickname'], cmsUser::getProfileURL($login));
	$inPage->addPathway($_LANG['BOOKMARKS'], '/bookmarks/'.$login);
	$inPage->addHeadJS('components/bookmarks/js/zakl.js');

/////////////////////////////// закладки пользователя /////////////////////////////////////////////////

if ($do=='view'){

	$inPage->setTitle(''.$usr['nickname'].': '.$_LANG['BOOKMARKS_SITE'].'.');

	$page    = $inCore->request('page', 'int', 1);
	$perpage = 10;

	//Сортировка
	if ($inCore->inRequest('orderby')) { 
		$orderby = $inCore->request('orderby', 'str');
		cmsUser::sessionPut('bm_orderby', $orderby);
	} elseif(cmsUser::sessionGet('bm_orderby')) { 
		$orderby = cmsUser::sessionGet('bm_orderby');
	} else {
		$orderby = 'id'; 
	}

	if ($inCore->inRequest('orderto')) { 
		$orderto = $inCore->request('orderto', 'str');;
		cmsUser::sessionPut('bm_orderto', $orderto);
	} elseif(cmsUser::sessionGet('bm_orderto')) { 
		$orderto = cmsUser::sessionGet('bm_orderto');
	} else {
		$orderto = 'desc'; 
	}

    if ($orderby != 'id' && $orderby != 'target' && $orderby != 'title') { $orderby='id'; }
    if ($orderto != 'desc' && $orderto != 'asc') { $orderto='desc'; }

	$zakls = $model->getUserBookmarks($usr['id'], $total, $page, $perpage, $orderby, $orderto);

    $smarty = $inCore->initSmarty('components', 'com_bookmarks_view.tpl');
	$smarty->assign('messages', cmsCore::getSessionMessages());	
	$smarty->assign('zakl', $zakls);
	$smarty->assign('orderto', $orderto);
	$smarty->assign('orderby', $orderby);
	$smarty->assign('myprofile', $myprofile);
	$smarty->assign('is_admin', $inUser->is_admin);
	$smarty->assign('total', $total);
	$smarty->assign('usr', $usr);
	$smarty->assign('pagebar', cmsPage::getPagebar($total, $page, $perpage, 'javascript:centerLink(\'/bookmarks/'.$login.'-%page%\')'));
    $smarty->display('com_bookmarks_view.tpl');
	if ($inCore->inRequest('of_ajax')) { echo ob_get_clean(); exit; }

}

/////////////////////////////// Удалить закладку/////////////////////////////////////////////////////

if ($do=='delete'){

	if (!$myprofile && !$inUser->is_admin) { cmsCore::error404(); }

	$zakl = $model->getBookmarkById($id);
	if (!$zakl) { cmsCore::error404(); }

	if (!$inCore->inRequest('godelete')){
		
		$inPage->setTitle($_LANG['BOOKMARKS_DEL']);
		$inPage->addPathway($_LANG['BOOKMARKS_DEL']);

		$confirm['title']              = $_LANG['BOOKMARKS_DEL'];
		$confirm['text']               = $_LANG['BOOKMARKS_REALU_DEL'].' "'.$zakl['title'].'"?';
		$confirm['action']             = '/bookmarks/'.$login.'/delete'.$id.'.html';
		$confirm['yes_button']         = array();
		$confirm['yes_button']['type'] = 'submit';
		$confirm['yes_button']['name'] = 'godelete';
		$smarty = $inCore->initSmarty('components', 'action_confirm.tpl');
		$smarty->assign('confirm', $confirm);
		$smarty->display('action_confirm.tpl');
		if ($inCore->inRequest('of_ajax')) { echo ob_get_clean(); exit; }

	} else {

		$model->deleteBookmark($id);
		cmsCore::addSessionMessage($_LANG['BOOKMARK'].' "'.$zakl['title'].'" '.$_LANG['SUCCESS_DELETE'].'.', 'info');
		//Возвращаемся в список закладок
		$inCore->redirect('/bookmarks/'.$login);

	}
}

/////////////////////////////// Добавить закладку/////////////////////////////////////////////////////

if ($do=='add'){

	if($_SERVER['HTTP_X_REQUESTED_WITH'] != 'XMLHttpRequest') { die(1); }
	
	if (!$myprofile) { die(2); }

	$href 	   = $inCore->request('href', 'str', '');
	$target	   = $inCore->request('target', 'str', 0);
	$target_id = $inCore->request('target_id', 'int', 0);

	if (!$target_id) { die(3); }
	// Проверяем назначение
	if (!preg_match('/^([a-zA-Z0-9\_]+)$/i', $target)) { die(4); }
	// Обрезаем ненужное в ссылке
	$href = preg_replace ('/[^a-z0-9_\.\/\-]/i', '', $href);
	
	// если не авторизованы, выдаем ошибку и выходим
    if (!$inUser->id) { echo ob_get_clean(); exit; }

	$is_zakl = $model->isBookmarkByHref($inUser->id, $href);
	if ($is_zakl){
		echo '<a title="'.$_LANG['BOOKMARKS_MY'].'" class="aktive" href="/bookmarks"></a>';  echo ob_get_clean(); exit;
	}
	
	switch ($target){
		case 'blog': 
				$item = $inDB->get_fields('cms_blog_posts', "id = '$target_id'", 'id, title, content_html as description');
				// Убираем тег [cut]
				$regex  = '/\[(cut=)\s*(.*?)\]/i';
				$item['description'] = preg_replace($regex, '', $item['description']);
				// Убираем теги, т.к. после усечения текста могут появиться незакрытые.
				$item['description'] = strip_tags($item['description']);
				// Если тект больше 400 символов, отсекаем
				if (strlen($item['description'])>400) { $item['description'] = substr($item['description'], 0, 400). '....'; }
				break;
		case 'content':
				$item = $inDB->get_fields('cms_content', "id = '$target_id'", 'id, title, description');
				$item['description'] = nl2br($item['description']);
				break;
		case 'photo':
				$item = $inDB->get_fields('cms_photo_files f INNER JOIN cms_photo_albums cat ON cat.id = f.album_id', "f.id = '$target_id'", 'f.id, f.title, f.description, f.file, cat.id as a_id, cat.title as a_title');
				$description_photo = '<div class="con_image"><a href="/photos/photo'.$item['id'].'.html" class="act_photo"><img border="0" alt="'.$item['title'].'" src="/images/photos/small/'.$item['file'].'" /></a></div>';
				$category = $_LANG['PHOTO_FROM_ALBUM'].': "<a href="/photos/'.$item['a_id'].'">'.$item['a_title'].'</a>".<br>';
				$item['description'] = $description_photo.'<br>'.$category.'<br>'.nl2br($item['description']);
				break;
		case 'club':
				$item = $inDB->get_fields('cms_clubs', "id = '$target_id'", 'id, title, description, imageurl');
				$item['imageurl'] = $item['imageurl'] ? '/images/clubs/small/'.$item['imageurl'] : '/images/clubs/nopic.jpg';
				$description_photo = '<div class="con_image"><a href="/clubs/'.$item['id'].'" class="act_photo"><img src="'.$item['imageurl'].'"  border="0" alt="'.$item['title'].'"/></a></div>';
				$item['description'] = $description_photo . $item['description'];
				break;
		case 'forum':
				$item = $inDB->get_fields('cms_forum_threads t INNER JOIN cms_forums f ON t.forum_id = f.id', "t.id = '$target_id'", 't.id, t.title, t.description, f.title as forum, f.id as fid');
				$description_photo = $_LANG['FORUM_FROM'].': "<a href="/forum/'.$item['fid'].'">'.$item['forum'].'</a>".<br>';
				$item['description'] = $description_photo . $item['description'];
				break;
   }

	$item['user_id']   = $inUser->id;
	$item['href']      = $href;
	$item['target']    = $target;
	$item['target_id'] = $item['id'];

	$model->addBookmark($item);
	
	echo '<a title="'.$_LANG['BOOKMARKS_MY'].'" class="aktive" href="/bookmarks"></a>';

	echo ob_get_clean(); exit;
}

//============================================================================//

}

?>