<?php

class p_bookmarks extends cmsPlugin {

// ==================================================================== //

    public function __construct(){
        
        parent::__construct();

        // Информация о плагине

        $this->info['plugin']           = 'p_bookmarks';
        $this->info['title']            = 'Instant Bookmarks';
        $this->info['description']      = '';
        $this->info['author']           = 'InstantCMS Team';
        $this->info['version']          = '1.0';

        // События, которые будут отлавливаться плагином

		// События на добавление закладки
        $this->events[]                 = 'GET_POST';
        $this->events[]                 = 'GET_ARTICLE';
		$this->events[]                 = 'GET_PHOTO';
		$this->events[]                 = 'GET_SINGLE_CLUB';
		$this->events[]                 = 'GET_FORUM_THREAD';

		// При удалении материала закладки, удалять закладку
        $this->events[]                 = 'DELETE_POST';
        $this->events[]                 = 'DELETE_ARTICLE';
		$this->events[]                 = 'DELETE_PHOTO';
		$this->events[]                 = 'DELETE_CLUB';

    }

// ==================================================================== //

    /**
     * Процедура установки плагина
     * @return bool
     */
    public function install(){

        return parent::install();

    }

// ==================================================================== //

    /**
     * Процедура обновления плагина
     * @return bool
     */
    public function upgrade(){

        return parent::upgrade();

    }

// ==================================================================== //

    /**
     * Обработка событий
     * @param string $event
     * @param mixed $item
     * @return mixed
     */
    public function execute($event, $item){

        parent::execute();
		
		if(@$_SERVER['HTTP_X_REQUESTED_WITH'] == 'XMLHttpRequest') { return $item; }

		$inUser = cmsUser::getInstance();
		if (!$inUser->id ) { return $item; }

		echo '<script src="/components/bookmarks/js/zakl.js" type="text/javascript"></script>'; 
        
		switch ($event){
            case 'GET_POST': 		 $item = $this->echoBookmark($item, 'blog'); break;
            case 'GET_ARTICLE': 	 $item = $this->echoBookmark($item, 'content'); break; 
			case 'GET_PHOTO': 		 $item = $this->echoBookmark($item, 'photo'); break; 
			case 'GET_SINGLE_CLUB':	 $item = $this->echoBookmark($item, 'club'); break; 
			case 'GET_FORUM_THREAD': $item = $this->echoBookmark($item, 'forum'); break; 
			
            case 'DELETE_POST': 	 $item = $this->eventDeleteBookmark($item, 'blog'); break;
            case 'DELETE_ARTICLE': 	 $item = $this->eventDeleteBookmark($item, 'content'); break; 
			case 'DELETE_PHOTO':	 $item = $this->eventDeleteBookmark($item, 'photo'); break; 
			case 'DELETE_CLUB':		 $item = $this->eventDeleteBookmark($item, 'club'); break; 
        }

        return $item;

    }

// ==================================================================== //

    private function isBookmark($href){
		
		$inDB   = cmsDatabase::getInstance();
		$inUser = cmsUser::getInstance();

		$user_id = $inUser->id;
		
		if (!$user_id) { return false; }

		$is_zakl = $inDB->rows_count('cms_user_zakladki', "user_id = '$user_id' AND href = '{$href}'");

        return $is_zakl ? true : false;

    }

// ==================================================================== //

    public function eventDeleteBookmark($item_id, $target){
		
		$inDB = cmsDatabase::getInstance();
		
		if (!$item_id){ return false; }

		$inDB->query("DELETE FROM cms_user_zakladki WHERE target_id = '$item_id' AND target = '$target' LIMIT 1");

        return true;

    }

// ==================================================================== //

    private function echoBookmark($item, $target) {

		$inCore = cmsCore::getInstance();
			
		$href   = $inCore->strClear($_SERVER['REQUEST_URI']);

		if (!$this->isBookmark($href)) {

			echo '<div id="zakctrl" class="favorite" align="right"><a title="Добавить в закладки" onclick="addBook(\''.$href.'\', \''.$target.'\', \''.$item['id'].'\')" href="javascript:void(0);"></a></div>';
			
		} else {
			
			echo '<div id="zakctrl" class="favorite" align="right"><a class="aktive" title="У Вас в закладках" href="/bookmarks"></a></div>';
			
		}

        return $item;

    }

// ==================================================================== //

}

?>
